local anim8 = require 'anim8'
lg = love.graphics

local temps_ = 4
local selected = 0

local spinning
local image

-- clone a random animation and pause it
local toss = function()
	local anim = spinning[math.random(1, #spinning)]
	anim = anim:clone()
	anim:pause()
	return anim
end

local currentAnim
local rolls

-- clone k (or 3) random animations and start first one
local roll = function(k)
	k = k or 3
	rolls = {}
	for i = 1, k do rolls[i] = toss() end
	currentAnim = 1
	rolls[currentAnim]:resume()
end

-- called when animation ends, so we can resume the next one
local onLoop = function()
	rolls[currentAnim]:pauseAtEnd()
	currentAnim = currentAnim + 1
	if currentAnim > #rolls then
		currentAnim = #rolls -- the last one finished
	else
		--rolls[currentAnim]:pauseAtStart() -- not needed because already at start
		rolls[currentAnim]:resume() -- resume next
	end
end

function love.load()
	image = love.graphics.newImage('media/1945.png')

						 -- frame, image,    offsets, border
	local g32 = anim8.newGrid(32,32, 268,169,   3,3,     1)

	spinning = {
		anim8.newAnimation(g32('1-8',1), 0.1, onLoop),
		anim8.newAnimation(g32('1-8',2), 0.1, onLoop),
		anim8.newAnimation(g32('1-8',3), 0.1, onLoop)		
	}
	
	result = {		
		anim8.newAnimation(g32('1-8',4), 0.1, onLoop),
		anim8.newAnimation(g32('1-8',5), 0.1, onLoop)
	}
	
	roll()
end

-- only draw those we resumed via onLoop
function love.draw()
  for i=1, currentAnim do
    rolls[i]:draw(image, i*75, 10)
  end
  
  lg.print("TIMER: "..math.ceil(temps_).."\nSELECTED: "..selected,10,200)	
end

-- update all. It doesn't really matter because invisible ones are paused
-- or you can update the ones <= currentAnim
function love.update(dt)
  for i=1,#rolls do
    rolls[i]:update(dt)
  end
  
  -- add few stuff to rewind 1 random animation selected with pauseAtStart() but ain't seems smooth
  if temps_ >	0 then temps_ = temps_ - 1*dt end		
  if temps_ <= 0 then temps_ = 0 
	selected = math.random(1, 3)	
	temps_ = 4
  end
  
  if selected ~= 0 then rolls[selected]:pauseAtStart() end
  
end

-- esc to exit, space to re-roll
function love.keypressed(key)
	if key == 'escape' then love.event.quit() end
	if key == "space" then roll() end
end
